package ggsoftware.audiostreamer;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "ggsoftware.audiostreamer", "ggsoftware.audiostreamer.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "ggsoftware.audiostreamer", "ggsoftware.audiostreamer.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "ggsoftware.audiostreamer.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.audio.AudioStreamer _streamer = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static double _freq = 0;
public static double _dur = 0;
public static double _samplerate = 0;
public static double _numsamples = 0;
public static double _d = 0;
public static double _vol = 0;
public static short _val = (short)0;
public static int _deltat = 0;
public static int _offsett = 0;
public static double _i = 0;
public static double _j = 0;
public static byte[] _smp = null;
public static float _x1 = 0f;
public static float _y1 = 0f;
public static float _x2 = 0f;
public static float _y2 = 0f;
public anywheresoftware.b4a.objects.SeekBarWrapper _seekbar1 = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _seekbar2 = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _seekbar3 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext2 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext3 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext4 = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _seekbar4 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _canvas1 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 57;BA.debugLine="Activity.LoadLayout(\"1.bal\")";
mostCurrent._activity.LoadLayout("1.bal",mostCurrent.activityBA);
 //BA.debugLineNum = 58;BA.debugLine="Activity.Title=\"AudioStreamer2\"";
mostCurrent._activity.setTitle((Object)("AudioStreamer2"));
 //BA.debugLineNum = 60;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 61;BA.debugLine="streamer.Initialize(\"streamer\", 11025, True, 16, streamer.VOLUME_MUSIC)";
_streamer.Initialize(processBA,"streamer",(int) (11025),anywheresoftware.b4a.keywords.Common.True,(int) (16),_streamer.VOLUME_MUSIC);
 //BA.debugLineNum = 62;BA.debugLine="streamer.StartPlaying";
_streamer.StartPlaying();
 //BA.debugLineNum = 63;BA.debugLine="timer1.Initialize(\"timer1\", deltaT+offsetT)";
_timer1.Initialize(processBA,"timer1",(long) (_deltat+_offsett));
 };
 //BA.debugLineNum = 67;BA.debugLine="timer1.Enabled = True'False'True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 69;BA.debugLine="EditText1.Text=freq";
mostCurrent._edittext1.setText((Object)(_freq));
 //BA.debugLineNum = 70;BA.debugLine="EditText2.Text=vol";
mostCurrent._edittext2.setText((Object)(_vol));
 //BA.debugLineNum = 71;BA.debugLine="EditText3.Text=deltaT";
mostCurrent._edittext3.setText((Object)(_deltat));
 //BA.debugLineNum = 72;BA.debugLine="EditText4.Text=offsetT";
mostCurrent._edittext4.setText((Object)(_offsett));
 //BA.debugLineNum = 74;BA.debugLine="smp=create_sample(deltaT)";
_smp = _create_sample(_deltat);
 //BA.debugLineNum = 76;BA.debugLine="Canvas1.Initialize(Panel1)";
mostCurrent._canvas1.Initialize((android.view.View)(mostCurrent._panel1.getObject()));
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 83;BA.debugLine="timer1.Enabled = False";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
 //BA.debugLineNum = 171;BA.debugLine="Sub Button1_Click ' show sample";
 //BA.debugLineNum = 176;BA.debugLine="End Sub";
return "";
}
public static byte[]  _create_sample(int _duration) throws Exception{
byte[] _snd = null;
 //BA.debugLineNum = 115;BA.debugLine="Sub create_sample(Duration As Int) As Byte()";
 //BA.debugLineNum = 116;BA.debugLine="dur = Duration / 1000'0";
_dur = _duration/(double)1000;
 //BA.debugLineNum = 118;BA.debugLine="numSamples = sampleRate * dur";
_numsamples = _samplerate*_dur;
 //BA.debugLineNum = 120;BA.debugLine="Dim snd((2 * numSamples)+2) As Byte";
_snd = new byte[(int) ((2*_numsamples)+2)];
;
 //BA.debugLineNum = 121;BA.debugLine="For i = 0 To numSamples '- 1";
{
final double step56 = 1;
final double limit56 = _numsamples;
for (_i = 0; (step56 > 0 && _i <= limit56) || (step56 < 0 && _i >= limit56); _i = ((double)(0 + _i + step56))) {
 //BA.debugLineNum = 122;BA.debugLine="d = Sin((2 * cPI * i) / (sampleRate / freq))";
_d = anywheresoftware.b4a.keywords.Common.Sin((2*anywheresoftware.b4a.keywords.Common.cPI*_i)/(double)(_samplerate/(double)_freq));
 //BA.debugLineNum = 123;BA.debugLine="val = d * 32767 * vol";
_val = (short) (_d*32767*_vol);
 //BA.debugLineNum = 124;BA.debugLine="snd(i * 2) = Bit.AND(0xff, val)";
_snd[(int) (_i*2)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (0xff),(int) (_val)));
 //BA.debugLineNum = 125;BA.debugLine="snd(i * 2 + 1) = Bit.ShiftRight(Bit.AND(0xff00, val), 8)";
_snd[(int) (_i*2+1)] = (byte) (anywheresoftware.b4a.keywords.Common.Bit.ShiftRight(anywheresoftware.b4a.keywords.Common.Bit.And((int) (0xff00),(int) (_val)),(int) (8)));
 }
};
 //BA.debugLineNum = 128;BA.debugLine="Return snd";
if (true) return _snd;
 //BA.debugLineNum = 129;BA.debugLine="End Sub";
return null;
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 40;BA.debugLine="Private SeekBar1 As SeekBar";
mostCurrent._seekbar1 = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Private SeekBar2 As SeekBar";
mostCurrent._seekbar2 = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Private SeekBar3 As SeekBar";
mostCurrent._seekbar3 = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Private EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Private EditText2 As EditText";
mostCurrent._edittext2 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Private EditText3 As EditText";
mostCurrent._edittext3 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Private EditText4 As EditText";
mostCurrent._edittext4 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Private SeekBar4 As SeekBar";
mostCurrent._seekbar4 = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Private Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Dim Canvas1 As Canvas";
mostCurrent._canvas1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim streamer As AudioStreamer";
_streamer = new anywheresoftware.b4a.audio.AudioStreamer();
 //BA.debugLineNum = 19;BA.debugLine="Dim timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 20;BA.debugLine="Dim freq As Double = 500 'Int";
_freq = 500;
 //BA.debugLineNum = 21;BA.debugLine="Dim dur As Double";
_dur = 0;
 //BA.debugLineNum = 22;BA.debugLine="Dim sampleRate As Double'Int";
_samplerate = 0;
 //BA.debugLineNum = 23;BA.debugLine="sampleRate = 11025";
_samplerate = 11025;
 //BA.debugLineNum = 24;BA.debugLine="Dim numSamples As Double'Int";
_numsamples = 0;
 //BA.debugLineNum = 25;BA.debugLine="Dim d As Double";
_d = 0;
 //BA.debugLineNum = 26;BA.debugLine="Dim vol As Double =0.1";
_vol = 0.1;
 //BA.debugLineNum = 27;BA.debugLine="Dim val As Short";
_val = (short)0;
 //BA.debugLineNum = 28;BA.debugLine="Dim deltaT As Int=100 '1000 '100 '10";
_deltat = (int) (100);
 //BA.debugLineNum = 29;BA.debugLine="Dim offsetT As Int=0";
_offsett = (int) (0);
 //BA.debugLineNum = 30;BA.debugLine="Dim i,j As Double'Int";
_i = 0;
_j = 0;
 //BA.debugLineNum = 31;BA.debugLine="Dim smp() As Byte";
_smp = new byte[(int) (0)];
;
 //BA.debugLineNum = 33;BA.debugLine="Dim x1,y1,x2,y2 As Float";
_x1 = 0f;
_y1 = 0f;
_x2 = 0f;
_y2 = 0f;
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _seekbar1_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 133;BA.debugLine="Sub SeekBar1_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 134;BA.debugLine="freq=SeekBar1.Value";
_freq = mostCurrent._seekbar1.getValue();
 //BA.debugLineNum = 136;BA.debugLine="EditText1.Text=freq";
mostCurrent._edittext1.setText((Object)(_freq));
 //BA.debugLineNum = 142;BA.debugLine="smp=create_sample(deltaT)";
_smp = _create_sample(_deltat);
 //BA.debugLineNum = 144;BA.debugLine="End Sub";
return "";
}
public static String  _seekbar2_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 146;BA.debugLine="Sub SeekBar2_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 147;BA.debugLine="vol=SeekBar2.Value/5000";
_vol = mostCurrent._seekbar2.getValue()/(double)5000;
 //BA.debugLineNum = 148;BA.debugLine="EditText2.Text=vol";
mostCurrent._edittext2.setText((Object)(_vol));
 //BA.debugLineNum = 150;BA.debugLine="smp=create_sample(deltaT)";
_smp = _create_sample(_deltat);
 //BA.debugLineNum = 151;BA.debugLine="End Sub";
return "";
}
public static String  _seekbar3_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 153;BA.debugLine="Sub SeekBar3_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 154;BA.debugLine="deltaT=SeekBar3.Value";
_deltat = mostCurrent._seekbar3.getValue();
 //BA.debugLineNum = 155;BA.debugLine="EditText3.Text=deltaT";
mostCurrent._edittext3.setText((Object)(_deltat));
 //BA.debugLineNum = 156;BA.debugLine="timer1.Initialize(\"timer1\", deltaT+offsetT)";
_timer1.Initialize(processBA,"timer1",(long) (_deltat+_offsett));
 //BA.debugLineNum = 158;BA.debugLine="smp=create_sample(deltaT)";
_smp = _create_sample(_deltat);
 //BA.debugLineNum = 160;BA.debugLine="End Sub";
return "";
}
public static String  _seekbar4_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 162;BA.debugLine="Sub SeekBar4_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 163;BA.debugLine="offsetT=SeekBar4.Value";
_offsett = mostCurrent._seekbar4.getValue();
 //BA.debugLineNum = 164;BA.debugLine="EditText4.Text=offsetT";
mostCurrent._edittext4.setText((Object)(_offsett));
 //BA.debugLineNum = 166;BA.debugLine="timer1.Initialize(\"timer1\", deltaT+offsetT)";
_timer1.Initialize(processBA,"timer1",(long) (_deltat+_offsett));
 //BA.debugLineNum = 168;BA.debugLine="End Sub";
return "";
}
public static String  _timer1_tick() throws Exception{
 //BA.debugLineNum = 86;BA.debugLine="Sub Timer1_Tick";
 //BA.debugLineNum = 95;BA.debugLine="streamer.Write(smp)";
_streamer.Write(_smp);
 //BA.debugLineNum = 98;BA.debugLine="End Sub";
return "";
}
}
